/*
 * display_data.hpp
 *
 *  Created on: 18 mars 2015
 *      Author: dominique
 */

#include <boost/graph/adjacency_list.hpp>
#include <boost/graph/graph_traits.hpp>
#include <boost/graph/connected_components.hpp>


using namespace boost ;

#ifndef SRC_DISPLAY_DATA_HPP_
#define SRC_DISPLAY_DATA_HPP_


	  // create a typedef for the Graph type
typedef adjacency_list<listS, vecS, undirectedS> graphe;


/**
 *   affiche le premier triangle de la liste
 */
void display_first_triangle(
		 	 	 	 	 	const TransactionTable& tt,
							const vector<int>& list_transactions,
							const vector<string>& initial_objects_names) ;


/**
 *   affiche chaque transaction désignés par list_objects
 *   (les noms des objets initiaux de chaque transaction sont affichés)
 */
void display_objects_names(
							const set<int>& initial_objects,
							const vector<string>& initial_objects_names) ;



/**
 *   affiche chaque transaction désignée par list_objects
 *   (les noms des objets initiaux de chaque transaction sont affichés)
 */
void display_n_objects_names(
		                    int n,
		 	 	 	 	 	const TransactionTable& tt,
							const vector<int>& list_transactions,
							const vector<string>& initial_objects_names) ;

void display_objects_names(
							const vector<int>& initial_objects,
							const vector<string>& initial_objects_names
						  ) ;


void display_objects_names(
							const TransactionTable& tt,
							const vector<int>& list_objects,
							const vector<string>& objects_names) ;


void outputOriginalPattern(
							bool show_tids,
							TransactionTable& tt,
							const Transaction& occs,
							set_t pattern,
							int set_support,
							const vector<string>& items_names
				  ) ;


void outputPattern(
				   bool show_tids, TransactionTable& tt,
				   const Transaction& occs,
				   set_t pattern, int set_support
				  ) ;


void outputLocalPattern(
				   	   	 bool show_tids,
						 const TransactionTable& tt,
						 const vector<element_t>& occs_cci,
						 set_t closed_pattern_cci,
						 int set_support_cci,
						 const vector<string>& items_names
						) ;

	/**
	 * each Transaction of tt contains a list of adjacences.
	 * each list of adjacences contains the indices of the transactions in tt
	 * that are connected to the current transaction
	 */
void print_adjacences(TransactionTable tt) ;



/**
 * print the initial objects adajacent to the object described by
 * the transaction t
 */
void print_initial_objects_transaction(const Transaction& t) ;


/**
 * each Transaction of tt contains a list of adjacences.
 * each list of adjacences contains the indices of the transactions in tt
 * that are connected to the current transaction
 */
void print_initial_objects(const TransactionTable& tt) ;


/**
 * each Transaction of tt contains a list of adjacences.
 * each list of adjacences contains the indices of the transactions in tt
 * that are connected to the current transaction
 */
void print_selection_initial_objects(const TransactionTable& tt,
									 const set<element_t>& list) ;




#endif /* SRC_DISPLAY_DATA_HPP_ */
