/*
 * graph.cpp
 *
 *  Created on: 17 avr. 2015
 *      Author: dominique
 */

#include <iostream>
#include "graph.hpp"


void displayVertices(Graphe& g)
{
	pair<vertex_iterator, vertex_iterator> pv = vertices(g) ;

	for (vertex_iterator vi = pv.first ; vi != pv.second ; ++vi)
	{
	  cout << (g)[*vi].ident <<  ","  ;
	}

	cout << endl ;
}


void displayEdges(Graphe& g)
{
	pair<edge_iterator, edge_iterator> pe = edges(g) ;

	 for (edge_iterator ei = pe.first ; ei != pe.second ; ++ei)
	 {
		  vertex_descriptor s = source(*ei, g) ;
		  vertex_descriptor t = target(*ei, g) ;

		  cout << "(" << (g)[s].ident << "," << (g)[t].ident << ")" << endl ;
	 }
}


/*

vector<ComponentGraph> connected_components_subgraphs(Graphe const&g)
{
    vertex_component_map mapping = boost::make_shared<std::vector<unsigned long>>(num_vertices(g));
    size_t num = boost::connected_components(g, mapping->data());

    std::vector<ComponentGraph> component_graphs;

    for (size_t i = 0; i < num; i++)
        component_graphs.emplace_back(g,
            [mapping,i,&g](Graphe::edge_descriptor e) {
                return mapping->at(source(e,g))==i
                    || mapping->at(target(e,g))==i;
            },
            [mapping,i](Graphe::vertex_descriptor v) {
                return mapping->at(v)==i;
            });

    return component_graphs;
}

*/


