/*
 * read_write_data.cpp
 *
 *  Created on: 18 mars 2015
 *      Author: Dominique Bouthinon
 *
 */

#include <cstdlib>
#include <algorithm>
#include <vector>
#include <sstream>
#include <fstream>
#include <iostream>
#include <iterator>
#include <set>

#include "paraminer_local.hpp"
#include "paraminer_LC2.hpp"
#include "matrix.hpp"
//#include "mSet.hpp"
#include "read_write_data.hpp"
#include "utils.hpp"

using namespace std;


/*
 *	  get the strings inside s (strings are separated by a space)
 */
void get_strings(const string s, vector<string>& v)
{
						// construct a stream from the string
	  stringstream strstr(s);
	  istream_iterator<string> it(strstr);

	  while(it != istream_iterator<string>())
	  {
		  v.push_back(*it) ;
		  it++ ;
	  }
}


/*
 *	  get the int inside s (ints are separated by a space)
 */
void get_ints(const string s, vector<int>& v)
{
						// construct a stream from the string
	  stringstream strstr(s);
	  istream_iterator<string> it(strstr);
      int value ;

	  while(it != istream_iterator<string>())
	  {
		  value = atoi(it->c_str()) ;
		  v.push_back(value) ;
		  it++ ;
	  }
}


/**
 *  get the int values between the current line and the line containing stop
 */
void get_values(
				ifstream& input,
				string stop,
				vector<vector<int> >& values
			   )
{
	string line ;

	getline(input, line) ;
	// cout << line << endl ;

	while(line.find(stop) == string::npos)
	{
		 vector<int> v ;

		 get_ints(line, v)   ;
		 values.push_back(v) ;

		 getline(input, line) ;
		 // cout << line << endl ;
	}
}


void read_data(
				const string fileName,
				vector<string> & object_names,
				vector<string> & item_names,
				vector<vector<int> >& initial_objects,
				vector<vector<int> >& transacts,
				vector<vector<int> >& adjacences
			   )
{
	    ifstream input(fileName , ifstream::in); 	// ouvre fichier

	    if (input)
	    {
			string line;

			getline(input, line) ;						//  #-----fichier
			// cerr << line << endl ;

			getline(input, line) ;						// nom du fichier
			// cout << line << endl ;

			getline(input, line) ;						// #------objets
			// cout << line << endl ;

			getline(input,line)  ;						// object names
			// cout << line << endl ;

			get_strings(line, object_names) ;
			// displayVector("v", object_names) ;

			getline(input, line) ;						//  #------langage
			// cout << line << endl ;

			getline(input,line)  ;						// item names
			// cout << line << endl ;

			get_strings(line, item_names) ;
			// displayVector("v", item_names) ;

			getline(input,line)  ;						// #------- description
			// cout << line << endl ;

			get_values(input, "itemset", initial_objects) ;
			// displayVectorVector("initial_objects", initial_objects) ;

			get_values(input, "adjacences", transacts) ;
			// displayVectorVector("transacts", transacts) ;

			get_values(input, "end", adjacences) ;
			// displayVectorVector("adjacences", adjacences) ;
	    }
	    else
	    {
	    	cout << "the file " << fileName << " cannot be opened." << endl ;
	    }

}

