/**
 * class template row_matrix.hpp
 *
 * Dominique Bouthinon
 * LIPN, Université Paris 13 (France)
 * db@lipn.univ-paris13.fr
 *
 * represents a row of a matrix

 * This class can be used to represent any row matrix
 *
 * (the explicit use of this-> is  volunteer for sake of readability)
 */

#ifndef   	_ROW_MATRIX_HPP_
#define   	_ROW_MATRIX_HPP_

#include <iostream>
#include <vector>

using namespace std ;


template <typename T> class row_matrix: public vector<T>
{

	public:
						// constructeur
		row_matrix() ;

						// add e at the end of the row
		void addElement(T e) ;

						// add e at position i
		void addElement(T e, int i) ;

						// clear the row  (which becomes empty)
		void clearRow() ;

						// return the first element of the row
		T getFirtElement() ;

						// return the last element of the row
		T getLastElement() ;

						// return the element of position i
		T getElement(int i) ;


						// delete the element at position i
		void deleteElement(int i) ;

						// return the number of elements of the row
		int numberElements() ;

						// display the row
		void displayRow() ;

};


// ====================== DEFINITION METHODS ==================================

template <typename T> row_matrix<T>::row_matrix():vector<T>()
{
}


						// add e at the end of the row
template <typename T> void row_matrix<T>::addElement(T e)
{
	this->push_back(e) ;
}


						// add e at position i of the row
template <typename T> void row_matrix<T>::addElement(T e, int i)
{
	this->insert(this->begin() + i, e) ;
}


						// clear the row (which bbecomes empty)
template <typename T> void row_matrix<T>::clearRow()
{
		this->erase() ;
}


						// return the first element of the row
template <typename T> T row_matrix<T>::getFirtElement()
{
	this->front() ;
}

						// return the last element of the row
template <typename T> T row_matrix<T>::getLastElement()
{
	this->back() ;
}


						// return the element at position i
template <typename T> T row_matrix<T>::getElement(int i)
{
	return this->at(i) ;
}

						// delete the element at position i
template <typename T> void row_matrix<T>::deleteElement(int i)
{
	this->erase(this->begin() + i) ;
}

						// return the number of arrows
template <typename T> int row_matrix<T>::numberElements()
{
	return this->size() ;
}

						// display the row
template <typename T> void row_matrix<T>::displayRow()
{
	for (unsigned int i = 0 ; i < this->numberElements() ; i++)
	{
		cout << this->getElement(i) << " " ;
	}

	cout << endl ;
}


#endif

//==================== END CLASS TEMPLATE row_matrix.hpp =======================
